Bug 1325363 - multithreaded clients with concurrent pmNewContext suffer deadlocks or low performance
Summary: multithreaded clients with concurrent pmNewContext suffer deadlocks or low pe...
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: pcp
Version: 25
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: pcp-maint
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2016-04-08 14:29 UTC by Frank Ch. Eigler
Modified: 2017-11-16 18:37 UTC (History)
7 users (show)

Fixed In Version: pcp-3.11.2-2.fc24 pcp-3.11.2-1.fc22 pcp-3.11.2-2.fc23 pcp-3.11.3-1.el5
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-11-16 18:37:29 UTC


Attachments (Terms of Use)
test program for forthcoming fix (2.28 KB, text/plain)
2016-04-08 14:29 UTC, Frank Ch. Eigler
no flags Details

Description Frank Ch. Eigler 2016-04-08 14:29:48 UTC
Created attachment 1145152 [details]
test program for forthcoming fix

While parallelizing pmmgr's scanning logic, ran into a roadblock within libpcp, namely pmNewContext holding libpcp throughout its operation.  This means that opens to remote PM_CONTEXT_HOST's that are unreachable or slow serialize the client program, even if itself multithreaded.

A test case that demonstrates much better performance with a multithreaded pmNewContext (I have a prototype) shows outright deadlocks with current libpcp, not even just sloth.  Attaching test case.  Invoke with

  % ./multithread10 localhost localhost

Comment 1 Frank Ch. Eigler 2016-04-09 23:35:47 UTC
Patches posted to pcpfans.git for review via
http://oss.sgi.com/pipermail/pcp/2016-April/010171.html

Comment 2 Fedora Update System 2016-04-29 02:53:24 UTC
pcp-3.11.2-1.el5 has been submitted as an update to Fedora EPEL 5. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-394320f755

Comment 3 Fedora Update System 2016-04-29 17:21:53 UTC
pcp-3.11.2-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-bad5995fe9

Comment 4 Fedora Update System 2016-04-30 01:50:05 UTC
pcp-3.11.2-1.el5 has been pushed to the Fedora EPEL 5 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-394320f755

Comment 5 Fedora Update System 2016-04-30 02:23:02 UTC
pcp-3.11.2-1.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-f8f919a355

Comment 6 Fedora Update System 2016-04-30 02:23:42 UTC
pcp-3.11.2-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2016-53282a0c5a

Comment 7 Fedora Update System 2016-05-09 00:04:43 UTC
pcp-3.11.2-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 8 Fedora Update System 2016-05-10 17:53:06 UTC
pcp-3.11.2-1.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2016-05-10 17:59:38 UTC
pcp-3.11.2-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 10 Fedora Update System 2016-06-18 06:17:40 UTC
pcp-3.11.3-1.el5 has been pushed to the Fedora EPEL 5 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2016-4745f3e292

Comment 11 Frank Ch. Eigler 2016-06-21 10:57:15 UTC
The multithreading improvement patches have not been merged into 3.11.3.

Comment 12 Fedora Update System 2016-07-09 20:19:09 UTC
pcp-3.11.3-1.el5 has been pushed to the Fedora EPEL 5 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Jan Kurik 2016-07-26 04:16:51 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 25 development cycle.
Changing version to '25'.

Comment 14 Fedora End Of Life 2017-11-16 18:32:24 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.


Note You need to log in before you can comment on or make changes to this bug.